## Registre Docker

Ce dossier contient les ressources nécessaires pour lancer un registre Docker privé.
Ce registre sert à stocker l'ensemble des images Docker construites par Picasoft.

Il est accessible via HTTPS, donc par Traefik, et ne nécessite donc pas la création manuelle de certificats.

### Configuration

Les utilisateurs autorisés à accéder au registre sont configurés dans le fichier `auth.secrets`.
Le format est le suivant : un utilisateur par ligne, `<user>:<encrypted_password>`.

Pour plus de facilité, on peut lancer la commande suivante pour créer un nouvel utilisateur :
```bash
docker run --entrypoint htpasswd registry:2 -Bbn pica password >> ./auth
```

En remplaçant `pica` et `password` par les valeurs souhaitées.
Tous les identifiants doivent être renseigné dans le [pass](https://gitlab.utc.fr/picasoft/interne/pass).

Le reste de la configuration se fait essentiellement par l'environnement dans [Compose](./docker-compose.yml), et ne devrait pas avoir à être modifié.

### Mise à jour

Il suffit de changer le tag dans [Compose](./docker-compose.yml). En cas de mise à jour majeure (2 -> 3), regarder les instructions correspondantes sur le [Docker Hub](https://hub.docker.com/_/registry/).
